//----------------------------------------------------------------------
// PennyDesktopRunnable.java
// Author: Bob Dondero
//----------------------------------------------------------------------

package edu.princeton.penny;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import java.awt.BorderLayout;
import java.awt.Toolkit;
import java.awt.Dimension;

//----------------------------------------------------------------------

class PennyDesktopRunnable implements Runnable
{
   private String serverURL;
   private JTextField authorTextField = new JTextField("");
   private DefaultListModel bookListModel = new DefaultListModel();

   //-------------------------------------------------------------------

   public PennyDesktopRunnable(String serverURL)
   {
      this.serverURL = serverURL;
   }

   //-------------------------------------------------------------------

   private class AuthorDocumentListener implements DocumentListener
   {
      private void update()
      {
         String author = authorTextField.getText();

         WorkerThread workerThread =
            new WorkerThread(serverURL, author, bookListModel);
         workerThread.start();
      }

      public void changedUpdate(DocumentEvent event) { update(); }

      public void removeUpdate(DocumentEvent event) { update(); }

      public void insertUpdate(DocumentEvent event) { update(); }
   }

   //-------------------------------------------------------------------

   public void run()
   {
      JLabel authorLabel = new JLabel("Author:  ", JLabel.RIGHT);
      JList bookList = new JList(bookListModel);

      JPanel inputPanel = new JPanel();
      inputPanel.setLayout(new BorderLayout());
      inputPanel.add("West", authorLabel);
      inputPanel.add("Center", authorTextField);

      JFrame frame = new JFrame();
      frame.setTitle("Penny");
      frame.setLayout(new BorderLayout());
      frame.add("North", inputPanel);
      frame.add("Center", bookList);
      Toolkit kit = Toolkit.getDefaultToolkit();
      Dimension screenSize = kit.getScreenSize();
      int screenWidth = screenSize.width;
      int screenHeight = screenSize.height;
      frame.setSize(screenWidth/4, screenHeight/4);

      AuthorDocumentListener authorDocumentListener =
         new AuthorDocumentListener();

      authorTextField.getDocument().
         addDocumentListener(authorDocumentListener);

      frame.setLocationByPlatform(true);
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      frame.setVisible(true);
   }
}
